;EasyVENT demonstration program - EditableComboBox gadgets.
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES THE FOLLOWING EVENTS:
;   #OnKeyPress, #OnContextMenuPopup
;This short demo shows how to use EasyVENT to remove the beep from the edit control attached
;to an editable combobox and prevent the context menu from appearing.
;These operations would normally require the programmer to 'subclass' the edit control
;attached to the combo; a fiddly business!
;*********************************************************************************


;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************

Declare.l KeyPress(*sender.PB_Sender)
Declare.l ContextMenu(*sender.PB_Sender)

Define Event.l, text$

OpenWindow(0, 100, 100, 450, 250, "EasyVENT EditableComboBoxGadget demo.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)

CreateGadgetList(WindowID(0))
  ComboBoxGadget(1, 10, 40, 250, 100, #PB_ComboBox_Editable)
  AddGadgetItem(1, -1, "ComboBox editable...")
  text$="Hit return - no beep!"+Chr(10)+Chr(13)+Chr(10)+Chr(13)
  text$+"All characters turned to uppercase!"+Chr(10)+Chr(13)+Chr(10)+Chr(13)
  text$+"No right-click context menu!"
  text$+Chr(10)+Chr(13)+Chr(10)+Chr(13)+"All without subclassing!"
  
  TextGadget(2, 10, 90, 200, 140, text$)

;Set event handlers.
SetEventHandler(GadgetID(1), #OnKeyPress, @KeyPress())
SetEventHandler(GadgetID(1), #OnContextmenuPopup, @ContextMenu())

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************


;The following event procedure removes the beep on hitting the return key
;and turns all entered characters to uppercase.
Procedure.l KeyPress(*sender.PB_Sender)
  Protected result
  ;Remove beep on pressing the return key.
  If *sender\wParam <> #VK_RETURN
    ;Convert to upper case.
      *sender\wParam = Asc(UCase(Chr(*sender\wParam)))
      PerformDefaultWinProcessing(*sender)
      result = #Event_ReturnDefault
  EndIf
  ProcedureReturn #Event_ReturnFalse
EndProcedure

;The following event procedure prevents the context menu from appearing either by right-clicking
;or using shift-f10 etc.
Procedure.l ContextMenu(*sender.PB_Sender)
  ProcedureReturn #Event_ReturnFalse
EndProcedure

; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 33
; FirstLine = 20
; IDE Options = PureBasic 4.20 Beta 1 (Windows - x86)
; CursorPosition = 73
; FirstLine = 36
; Folding = -
; EnableXP