;EasyVENT demonstration program - ListView gadgets.
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES THE FOLLOWING EVENTS:
; #OnItemSelected, #OnMouseDown, #OnMouseUp 

;This short demo shows how to use EasyVENT to fool a gadget into believing that the user
;clicked the left mouse button when in fact the right button was clicked.
;We use this trick to use the right mouse button to select items in a ListBox gadget.
;*********************************************************************************


;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************

Declare.l SelectItem(*sender.PB_Sender)
Declare.l MouseDown(*sender.PB_Sender)
Declare.l MouseUp(*sender.PB_Sender)

Define Event.l, a, text$

OpenWindow(0, 100, 100, 350, 250, "EasyVENT ListViewGadget demo.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)
  CreateGadgetList(WindowID(0))
  TextGadget(0, 10, 10, 200, 20, "Select items by left or RIGHT click!")
  ListViewGadget(1, 10, 40, 250, 120)
    For a = 0 To 11
      AddGadgetItem (1, -1, "Item " + Str(a) + " of the Listview") ; define listview content
    Next
SetWindowLong_(GadgetID(1), #GWL_STYLE, GetWindowLong_(GadgetID(1), #GWL_STYLE)|#LBS_NOTIFY)
;Set event handlers.
  SetEventHandler(GadgetID(1), #OnItemSelected, @SelectItem())
  SetEventHandler(GadgetID(1), #OnMouseDown, @MouseDown())
  SetEventHandler(GadgetID(1), #OnMouseUp, @MouseUp())
  
Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************

Procedure.l SelectItem(*sender.PB_Sender)
  Debug "Selection of item: " + Str(GetGadgetState(1))
ProcedureReturn #Event_ReturnTrue ; Return not important.
EndProcedure

;The following runs when the user clicks a button whilst hovering over the ListBox gadget.
;We check to see if the right button was clicked and then change the underlying windows message
;to fool windows into thinking the left button was clicked.
Procedure.l MouseDown(*sender.PB_Sender)
  If *sender\uMsg = #WM_RBUTTONDOWN
    *sender\uMsg = #WM_LBUTTONDOWN
  EndIf
  PerformDefaultWinProcessing(*sender)
ProcedureReturn #Event_ReturnDefault
EndProcedure

;The following runs when the user releases a button whilst hovering over the ListBox gadget.
;We check to see if the right button was released and then change the underlying windows message
;to fool windows into thinking the left button was released.
Procedure.l MouseUp(*sender.PB_Sender)
  If *sender\uMsg = #WM_RBUTTONUP
    *sender\uMsg = #WM_LBUTTONUP
  EndIf
  PerformDefaultWinProcessing(*sender)
ProcedureReturn #Event_ReturnDefault
EndProcedure

; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 65
; FirstLine = 32
; IDE Options = PureBasic 4.20 Beta 1 (Windows - x86)
; CursorPosition = 28
; FirstLine = 6
; Folding = -