;EasyVENT demonstration program - Drag and drop items 3 (slightly harder example!)
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES THE FOLLOWING EVENTS:
;  #OnStartDragItem, #OnDropItem
;
;This demo shows how easy it is to drag and drop items from gadgets such as ListIcons
;using EasyVENT.
;Here we show how to drag multiple items from a list icon.
;*********************************************************************************


;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************

Declare.l DragItem(*sender.PB_Sender)
Declare.l DropItem(*sender.PB_Sender)

Define event.l, i

OpenWindow(0, 100, 100, 360, 200, "EasyVENT OLE drag and drop items demo 2.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)
  CreateGadgetList(WindowID(0))
  TextGadget(0, 10, 10, 290, 20, "Drop MULTIPLE ITEMS from the ListIcon gadget...")
  ListIconGadget(1,10,40,150,150,"Drag from",120,#PB_ListIcon_MultiSelect) 
  ListIconGadget(2,200,40,150,150,"Drag to",120) 
    For i = 1 To 10
      AddGadgetItem(1, -1, "Item " + Str(i))
    Next
  SetActiveGadget(1)

;Set event handlers.
  SetEventHandler(GadgetID(1), #OnDragItemStart, @DragItem())
  SetEventHandler(GadgetID(2), #OnDropItem, @DropItem())

;Enable drops to the second ListIcon gadget.
  EnableGadgetDrop(2, #PB_Drop_Text,#PB_Drag_Copy|#PB_Drag_Move)

Repeat
  event = WaitWindowEvent()
Until event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************


;Since the following handles only one gadget, we need not check which control etc.
;The return value is unimportant.
Procedure.l DragItem(*sender.PB_Sender)
Protected i, text$
  If GetGadgetState(1)>=0
    For i = 0 To CountGadgetItems(1)-1
      If GetGadgetItemState(1,i)
        If text$ : text$+Chr(9) : EndIf ;We use chr(9) as an item separator.
        text$+GetGadgetItemText(1,i)
      EndIf
    Next
  EndIf
  DragText(text$)
EndProcedure

;Since the following handles only one gadget, we need not check which control etc.
;The return value is unimportant.
Procedure.l DropItem(*sender.PB_Sender)
Protected i, count, item, text$
  If EventDropType() = #PB_Drop_Text
    text$ = EventDropText()
    count = CountString(text$,Chr(9))+1
    For i = 1 To count
      AddGadgetItem(2,GetGadgetState(2), StringField(text$,i,Chr(9))) ;Copy item to ListIcon.
    Next
  EndIf
EndProcedure


; IDE Options = PureBasic 4.20 Beta 1 (Windows - x86)
; CursorPosition = 43
; FirstLine = 26
; Folding = -
; EnableXP