;EasyVENT demonstration program - ScrollArea gadgets.
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES THE FOLLOWING EVENTS:
; #OnButtonClick, #OnMouseOver, #OnScroll

;This example is notable because of the problems inherent in attempting to attach an event
;to the 'client area' of a scroll area gadget.
;The problem is that the handle of the ScrollAreaGadget is not the same as the handle
;of the 'child' client area,
;*********************************************************************************

Define Event.l

;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************
Declare.l ButtonClick(*sender.PB_Sender)
Declare.l Scroll(*sender.PB_Sender)
Declare.l MouseOver(*sender.PB_Sender)

OpenWindow(0, 100, 100, 400, 250, "EasyVENT ScrollArea / ScrollBar demo.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)

CreateGadgetList(WindowID(0))
  ScrollAreaGadget(0, 10, 10, 290,120, 375, 155, 30)
    ButtonGadget  (1, 10, 10, 230, 30,"Button 1")
    ButtonGadget  (2, 50, 50, 230, 30,"Button 2")
    ButtonGadget  (3, 90, 90, 230, 30,"Button 3")
    TextGadget    (4,130,130, 230, 20,"This is the content of a ScrollAreaGadget!",#PB_Text_Right)
  CloseGadgetList() 
  ScrollBarGadget(5,  10, 140, 20,  90, 0, 100, 30, #PB_ScrollBar_Vertical)
  TextGadget(6,50,160, 130, 20,"Scroll the scroll-bar gadget.",#PB_Text_Right)


;Set event handlers.
SetEventHandler(GadgetID(1), #OnButtonClick, @ButtonClick())
SetEventHandler(GadgetID(0), #OnScroll, @Scroll())
SetEventHandler(GadgetID(5), #OnScroll, @Scroll())

;The following shows one way of attaching an event to the 'client area' of a scroll area gadget.
;The problem is that the handle of the ScrollAreaGadget is not the same as the handle of the 'child'
;client area,
SetEventHandler(GetParent_(GadgetID(1)), #OnMouseOver, @MouseOver())

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************

Procedure.l ButtonClick(*sender.PB_Sender)
  Debug "Clicked button 1."
ProcedureReturn #Event_ReturnTrue ;Return not important.
EndProcedure

;*sender\item contains the scroll box position.
;*sender\state contains the scroll bar code.
;*sender\hWnd contains the handle of the ScrollBar control or the window if we are dealing with
;a window's standard scroll bar.
;*sender\uMsg contains either #WM_HSCROLL or #WM_VSCROLL as appropriate.
Procedure.l Scroll(*sender.PB_Sender)
  PerformDefaultWinProcessing(*sender)
  If *sender\state=#SB_ENDSCROLL	
    Debug "Scrolling finished!"
  Else
    Debug "Scrolling!"
  EndIf
ProcedureReturn #Event_ReturnDefault
EndProcedure

Procedure.l MouseOver(*sender.PB_Sender)
  Debug "Mouseover scroll area child."
ProcedureReturn #Event_ReturnTrue ;Return not important this time.
EndProcedure


; IDE Options = PureBasic v4.00 - Beta 9 (Windows - x86)
; CursorPosition = 70
; FirstLine = 40
; IDE Options = PureBasic 4.10 (Windows - x86)
; CursorPosition = 45
; FirstLine = 17
; Folding = -